设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 100|回复: 9

图元加边框 求高手改进一下

[复制链接]
发表于 2020-7-29 17:05:23 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
只能一个个加边框,不能连续加,而且有时候加有误差,
(defun c:bb ()
  (setvar "cmdecho" 0)
  (setq ss (SSGET))
  (setq p1 (getvar "extmax"))
  (setq p2 (getvar "extmin"))
  (setq aaa (getreal "\n每边加(<30>?):"))
  (if (= aaa nil)
    (setq aaa 30.0)
  )
  (print p1)
  (setq p1 (mapcar '+ p1 (list aaa aaa 0.0)))
  (print p1)
  (setq p2 (mapcar '- p2 (list aaa aaa 0.0)))
  (command "rectangle"  p1 p2)
)
(princ)


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 19个

财富等级: 恭喜发财

发表于 2020-7-29 17:11:08 | 显示全部楼层
你这是给图的EXTMAX和EXTMIN画框,也不是给图元加的啊
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 57个

财富等级: 招财进宝

发表于 2020-7-29 20:58:29 | 显示全部楼层
你这用的command,肯定受捕捉影响啊,偏差是难免的,又不懂临时关闭捕捉。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2826个

财富等级: 家财万贯

发表于 2020-7-30 08:01:07 | 显示全部楼层
做一个热心并受欢迎的人
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 374个

财富等级: 日进斗金

发表于 2020-7-30 09:39:15 | 显示全部楼层
本帖最后由 pxr201419 于 2020-7-30 10:15 编辑

(defun c:bb  ()
   (setvar "osmode" 0)
   (setq aaa (getdist "\n每边加<30>"))
   (if (= aaa nil)
      (setq aaa 0.0))
   (prompt "\n选择要加框的对象")
   (cond ((setq ss (SSGET ":s"))
          (setq i 0)
          (while (< i (sslength ss))
             (vl-cmdf "_zoom" "o" (ssname ss i) "")
             (setq p1 (mapcar '+ (getvar "extmax") (list aaa aaa 0.0)))
             (setq p2 (mapcar '- (getvar "extmin") (list aaa aaa 0.0)))
             (vl-cmdf "_rectangle" p1 p2)
             (setq i (1+ i)))
          (vl-cmdf "_zoom" "o" ss "")))
   (princ))

extmax extmin是图形范围右上角和左下角的值,以它们画的矩形并不是图元的精确外包盒

点评

好像应该是这样的效果  详情 回复 发表于 5 天前
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 5 天前 | 显示全部楼层
pxr201419 发表于 2020-7-30 09:39
(defun c:bb  ()
   (setvar "osmode" 0)
   (setq aaa (getdist "\n每边加"))

好像应该是这样的效果
加边框.gif
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 374个

财富等级: 日进斗金

发表于 5 天前 | 显示全部楼层
(defun c:bb  ()
   (setvar "osmode" 0)
   (setq aaa (getdist "\n每边加<30>"))
   (if (= aaa nil)
      (setq aaa 0.0))
   (while (setq e (car(entsel "\n选择要加框的对象")))
      (vl-cmdf "_zoom" "o" e "")
      (setq p1 (mapcar '+ (getvar "extmax") (list aaa aaa 0.0)))
      (setq p2 (mapcar '- (getvar "extmin") (list aaa aaa 0.0)))
      (vl-cmdf "_rectangle" p1 p2)
      (vl-cmdf "_zoom" "p"))
   (princ))

点评

大哥这样弄出来外包盒比较精准了 (defun c:bb (/ e obj box pts) (while (setq e (car (entsel "\n请选取对象: "))) (setq obj (vlax-ename->vla-object e)) (setq box (Getbox obj)) (setq pts (map  详情 回复 发表于 3 天前
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 5 天前 | 显示全部楼层
本帖最后由 吴外安放 于 2020-8-4 17:15 编辑

你跟我说 extmax extmin是图形范围右上角和左下角的值,我好像弄错了,不应该是这样,应该要选取图元的大小,而不应该是 extmax extmin对吧,用这个好像都不精确
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 3 天前 | 显示全部楼层
本帖最后由 吴外安放 于 2020-8-6 16:46 编辑
pxr201419 发表于 2020-8-4 16:34
(defun c:bb  ()
   (setvar "osmode" 0)
   (setq aaa (getdist "\n每边加"))

大哥这样弄出来外包盒比较精准了  但这个只能选 一个对象,不能选多个对象的大外包
(defun c:bb (/ e obj box pts)
  (while (setq e (car (entsel "\n请选取对象: ")))
  (setq obj (vlax-ename->vla-object e))
  (setq box (Getbox obj))
  (setq pts (mapcar '(lambda (p1 p2)
         (getclosestpt obj (getplan p1 p2))
                     ) box (cdr (reverse (cons (car box) (reverse box))))
            )
  )
  (entmakex
    (append '((0 . "LWPOLYLINE")
       (100 . "AcDbEntity")
       (100 . "AcDbPolyline")
       (90 . 4)
       (70 . 1)
      )
     (mapcar
       '(lambda (x) (cons 10 (list (car x) (cadr x))))
       (pnts:box pts)
     )
    )
  )
    )
)
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 57个

财富等级: 招财进宝

发表于 前天 08:17 | 显示全部楼层
entsel就是选一个对象的,要多个对象的用SSGET
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-8-9 13:26 , Processed in 0.099677 second(s), 68 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表